#include <stdio.h>

#define MAXDIM 80

void charpointerswap(char **s, char **t)
{
	char *aux = *s;

	*s = *t;
	*t = aux;
}

char belong(char c, const char *set)
{
	const char *t = set;

	while(*t)
		if(*t++ == c)
			return 1;
	return 0;
}

char *tokenizza(char *l, const char *sep)
{
	static char *s;
	char *t;

	if(l)
		s = l;
	if(!s)
		return NULL;
	t = s;
	while(*t && !belong(*t,sep))
		t++;
	if(!*t) {
		if(s == t)
			return s = NULL;
		t = s;
		s = NULL;
		return t;
	}
	*t = 0;
	charpointerswap(&s,&t);
	s++;
	return *t ? t : tokenizza(NULL,sep);
}

int main(void)
{
	char line[MAXDIM+1];
	char sep[] = " \n\t\r";
	char *t = line;

	printf("Immetti linea:\n");
	while((*t++ = getchar()) != '\n');
	*--t = 0;
	t = tokenizza(line,sep);
	while(t) {
		printf("[%s]\n",t);
		t = tokenizza(NULL,sep);
	}
	putchar('\n');

	return 0;
}
